<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import Cropper from 'cropperjs';
import { ref, onMounted } from 'vue';

const source = ref<any>(null);
const imageRef = ref<any>(null);
const selectionRef = ref<any>(null);

defineProps<{
    image: string
}>();

const emits = defineEmits<{
    (e:'change', value: string):void
}>();

onMounted(()=>{
    setTimeout( async ()=>{
        try{
            await imageRef.value.$ready();
            imageRef.value.$center('contain');
            imageRef.value.scalable = false;
            handleGetBase64FromCanvas();
        }catch(error:any){
            console.error(error);
        }
    },1000);
})

//based on: https://github.com/fengyuanchen/cropperjs/issues/981#issuecomment-1949354091
const handleAction = (event:any) => {
  const cropperCanvas = source.value;
  if (!cropperCanvas) return;
  const cropperImage = imageRef.value;
  if (!cropperImage) return;
  const selection = selectionRef.value;
  if (!selection) return;

  const actionType = event.detail.action;
  // Extract image transform matrix
  const matrix = cropperImage.$getTransform();

  // Calculate the actual dimensions and position of the image
  const imageActualWidth = cropperImage.$image.width * matrix[0];
  const imageActualHeight = cropperImage.$image.height * matrix[3];
  const imageActualX = matrix[4] + (cropperImage.$image.width - imageActualWidth) / 2;
  const imageActualY = matrix[5] + (cropperImage.$image.height - imageActualHeight) / 2;

  // Initialize new position and size with current values
  let newX = selection.x;
  let newY = selection.y;
  let newWidth = selection.width;
  let newHeight = selection.height;

  if (actionType === 'move' || actionType === 'scale') {
        // Calculate new position ensuring selection does not exceed image boundaries
        newX = Math.max(imageActualX, Math.min(selection.x, imageActualX + imageActualWidth - selection.width));
        newY = Math.max(imageActualY, Math.min(selection.y, imageActualY + imageActualHeight - selection.height));
        
        if (actionType === 'scale') {
        // Adjust the selection size if the image is scaled
            newWidth = Math.min(newWidth, imageActualWidth);
            newHeight = Math.min(newHeight, imageActualHeight);

            // Adjust selection position again in case resizing has pushed it outside the image
            if (newX + newWidth > imageActualX + imageActualWidth) {
                newX = imageActualX + imageActualWidth - newWidth;
            }
            if (newY + newHeight > imageActualY + imageActualHeight) {
                newY = imageActualY + imageActualHeight - newHeight;
            }
        }
        
    } else if (actionType.includes('resize')) {
        // Handle specific resize actions here
        if (actionType === 'ne-resize') {
            if (newX + newWidth > imageActualX + imageActualWidth) {
                newWidth = imageActualX + imageActualWidth - newX; // Prevent right side from going outside
            }
            // Ensure top edge does not exceed the image boundary
            if (newY < imageActualY) {
                newHeight += newY - imageActualY; // Increase height to compensate for the upward movement
                newY = imageActualY;
            }
        }

        // Correct resizing for 'sw-resize'
        if (actionType === 'sw-resize') {
            // Ensure bottom edge does not exceed the image boundary
            if (newY + newHeight > imageActualY + imageActualHeight) {
                newHeight = imageActualY + imageActualHeight - newY;
            }
            // Adjust newX for 'sw-resize' if necessary (moved to the left beyond image boundary)
            if (newX < imageActualX) {
                newWidth += newX - imageActualX; // Adjust width to maintain size while moving left
                newX = imageActualX;
            }
        }

        // For north and west resize, adjust newX and newY
        if (actionType === 'n-resize' || actionType === 'nw-resize') {
            if (newY < imageActualY) {
                newHeight += newY - imageActualY; // Increase height to compensate for the upward movement
                newY = imageActualY;
            }
            newHeight = Math.min(newHeight, imageActualY + imageActualHeight - newY);
        }

        if (actionType === 'w-resize' || actionType === 'nw-resize') {
            if (newX < imageActualX) {
                newWidth += newX - imageActualX; // Increase width to compensate for the leftward movement
                newX = imageActualX;
            }
            newWidth = Math.min(newWidth, imageActualX + imageActualWidth - newX);
        }

        // Correct newWidth and newHeight for south and east directions to not exceed image boundaries
        if (actionType === 's-resize' || actionType === 'se-resize' || actionType === 'e-resize') {
            if (newX + newWidth > imageActualX + imageActualWidth) {
                newWidth = imageActualX + imageActualWidth - newX;
            }
            if (newY + newHeight > imageActualY + imageActualHeight) {
                newHeight = imageActualY + imageActualHeight - newY;
            }
        }
    }

    // Ensure selection does not exceed canvas boundaries (optional check for resize)
    if (newX + newWidth > cropperCanvas.clientWidth) {
        newWidth = cropperCanvas.clientWidth - newX;
    }
    if (newY + newHeight > cropperCanvas.clientHeight) {
        newHeight = cropperCanvas.clientHeight - newY;
    }

    // Update the selection if necessary
        if (newX !== selection.x || newY !== selection.y || newWidth !== selection.width || newHeight !== selection.height) {
        newWidth > newHeight ? newWidth = newHeight : newHeight = newWidth;
            selection.$change(newX, newY, newWidth, newHeight);
    }

    //handleGetBase64FromCanvas();
};

const handleGetBase64FromCanvas = ()=>{
    source.value.$toCanvas({
        beforeDraw: function (context:any, canvas:any) { 
            context.imageSmoothingQuality = 'high';
        }   
    }).then((canvas:any) => {
        const ctx = canvas.getContext('2d');
        const selection = selectionRef.value;
        ctx.clearRect(selection.x, selection.y, selection.width, selection.height);
        const imageDataUrl = canvas.toDataURL("image/png");
        emits('change', imageDataUrl);
    }).catch((error:any) => {
        console.error({ error });
    });
};

const handleActionEnd = ()=>{
    handleGetBase64FromCanvas();
};

</script>
<template>
    <div class="croppper-container">
        <div>
            <cropper-canvas class="min-h-96"
                ref="source" @action="handleAction" @actionend="handleActionEnd"
                >
                <cropper-image ref="imageRef" crossorigin="anonymous"
                    :src="image" :scalable="true" :translatable="true"
                />
                <cropper-shade></cropper-shade>
                <cropper-selection initial-coverage="0.5" :aspect-ratio="1" movable resizable outlined ref="selectionRef">
                    <cropper-handle theme-color="rgba(255, 255, 255, 0.35)"
                    action="move"
                    />
                    <cropper-handle action="nw-resize"></cropper-handle>
                    <cropper-handle action="ne-resize"></cropper-handle>
                    <cropper-handle action="se-resize"></cropper-handle>
                    <cropper-handle action="sw-resize"></cropper-handle>
                </cropper-selection>
            </cropper-canvas>
        </div>
    </div>
</template>